-- /*
--  * IBM Confidential OCO Source Material
--  *
--  * Licensed Materials - Property of IBM
--  * 5724-Y62 WebSphere Sensor Events
--  * (C) Copyright IBM Corp. 2009  All rights reserved.
--  *
--  * The source code for this program is not published or otherwise divested
--  * of its trade secrets, irrespective of what has been deposited with the
--  * U. S. Copyright Office.
--  *
--  * US Government Users Restricted Rights - Use, duplication or
--  * disclosure restricted by GSA ADP Schedule Contract with IBM
--  * Corp.
--  */
CREATE  USER TEMPORARY  TABLESPACE AVSTEMP1 PAGESIZE 4 K  MANAGED BY AUTOMATIC STORAGE EXTENTSIZE 16 OVERHEAD 10.5 PREFETCHSIZE 16 TRANSFERRATE 0.14 BUFFERPOOL  IBMDEFAULTBP^

CREATE PROCEDURE DCOESCHEMA.GenericDatacenterReport (IN itemType INTEGER,
					 IN locationId varchar(250))
  DYNAMIC RESULT SETS 1
BEGIN

DECLARE v_TABLE_EXISTS INT DEFAULT 0;
DECLARE c_TABLE_EXISTS CONDITION FOR SQLSTATE '42710';
DECLARE CONTINUE HANDLER FOR c_TABLE_EXISTS SET v_TABLE_EXISTS = 1;

DECLARE GLOBAL TEMPORARY TABLE ASSET_RESULTS(
ITEM_TYPE char(20),
ITEMID INTEGER,
TAGID varchar(96),
ITEM_PARENT varchar(32),
TimeSeen Timestamp,
LOCATION varchar(250),
ZoneName varchar(32),
PROP1 varchar(100));

IF v_TABLE_EXISTS = 1 THEN
delete from SESSION.ASSET_RESULTS;
END IF;

IF itemType <> 0 AND locationId IS NOT NULL THEN
   -- Retrieve all items with location, zone and last seen time details only
    INSERT INTO SESSION.ASSET_RESULTS
          SELECT DISTINCT ATYPE.AssetTypeName, A.AssetId, TH.TAGID, '', DCOESCHEMA.UNIXTIMESTAMP(BIGINT(TH.DTS)) AS TIME, L.LOCATION_ALIAS, ZONES.ZONE_NAME, AP.AssetPropertyValue
                FROM SAGE.TAGHISTORY TH, SAGE.LOCATION L, SAGE.Assets A, DCOESCHEMA.ITEM_TAG ITAG, SAGE.AssetProperties AP,  SAGE.AssetTypeProperties ATP, SAGE.AssetTypes ATYPE
		,DCOESCHEMA.LOCATION_ZONES LZ, DCOESCHEMA.ZONE_ITEMS ZONEITEMS
		LEFT JOIN DCOESCHEMA.ZONES ZONES ON ZONEITEMS.ZONE_ID=ZONES.ZONE_ID
		WHERE  TH.TAGID = ITAG.TAG_ID AND A.AssetId=ITAG.ITEM_ID AND
				(CASE WHEN ITAG.ENDDATE IS NOT NULL THEN ITAG.ENDDATE - CURRENT TIMEZONE ELSE CURRENT_TIMESTAMP - CURRENT TIMEZONE END ) >=  DCOESCHEMA.UNIXTIMESTAMP(BIGINT(TH.DTS)) AND
				ITAG.STARTDATE - CURRENT TIMEZONE <= DCOESCHEMA.UNIXTIMESTAMP(BIGINT(TH.DTS)) AND
				TH.LOCATION_ID = L.LOCATION_ID AND
				AP.AssetId = A.AssetId AND A.AssetTypeId=ATYPE.AssetTypeId  AND
				ATP.IsPrimaryIdentifier=1 AND 	AP.AssetTypePropertyId = ATP.AssetTypePropertyId
				AND (ZONEITEMS.ISCURRENT='Y' OR ZONEITEMS.ITEM_ID is null) and ZONEITEMS.ITEM_ID=A.AssetId
				AND TH.DTS in (select max(DTS) from SAGE.TAGHISTORY TH2 where TH.TAGID = TH2.TAGID)
				AND ATYPE.AssetTypeId = itemType 
				AND TH.LOCATION_ID = locationId
				AND AP.AssetId IN (SELECT AP.AssetId 		
						FROM SAGE.AssetProperties AP, SAGE.AssetTypeProperties ATP 
						WHERE AP.AssetTypePropertyId=ATP.AssetTypePropertyId 
						AND AP.AssetPropertyValue <> '3' 
						AND ATP.AssetTypePropertyName='com.ibm.rfid.atv.status')
    ;
END IF;
IF itemType <> 0 AND locationId ='' THEN
   -- Retrieve all items with location, zone and last seen time details only
    INSERT INTO SESSION.ASSET_RESULTS
          SELECT DISTINCT ATYPE.AssetTypeName, A.AssetId, TH.TAGID, '', DCOESCHEMA.UNIXTIMESTAMP(BIGINT(TH.DTS)) AS TIME, L.LOCATION_ALIAS, ZONES.ZONE_NAME, AP.AssetPropertyValue
                FROM SAGE.TAGHISTORY TH, SAGE.LOCATION L, SAGE.Assets A, DCOESCHEMA.ITEM_TAG ITAG, SAGE.AssetProperties AP,  SAGE.AssetTypeProperties ATP, SAGE.AssetTypes ATYPE
		,DCOESCHEMA.LOCATION_ZONES LZ, DCOESCHEMA.ZONE_ITEMS ZONEITEMS
		LEFT JOIN DCOESCHEMA.ZONES ZONES ON ZONEITEMS.ZONE_ID=ZONES.ZONE_ID
		WHERE  TH.TAGID = ITAG.TAG_ID AND A.AssetId=ITAG.ITEM_ID AND
				(CASE WHEN ITAG.ENDDATE IS NOT NULL THEN ITAG.ENDDATE - CURRENT TIMEZONE ELSE CURRENT_TIMESTAMP - CURRENT TIMEZONE END ) >=  DCOESCHEMA.UNIXTIMESTAMP(BIGINT(TH.DTS)) AND
				ITAG.STARTDATE - CURRENT TIMEZONE <= DCOESCHEMA.UNIXTIMESTAMP(BIGINT(TH.DTS)) AND
				TH.LOCATION_ID = L.LOCATION_ID AND
				AP.AssetId = A.AssetId AND A.AssetTypeId=ATYPE.AssetTypeId  AND
				ATP.IsPrimaryIdentifier=1 AND 	AP.AssetTypePropertyId = ATP.AssetTypePropertyId
				AND (ZONEITEMS.ISCURRENT='Y' OR ZONEITEMS.ITEM_ID is null) and ZONEITEMS.ITEM_ID=A.AssetId
				AND TH.DTS in (select max(DTS) from SAGE.TAGHISTORY TH2 where TH.TAGID = TH2.TAGID)
				AND ATYPE.AssetTypeId = itemType
				AND AP.AssetId IN (SELECT AP.AssetId 		
						FROM SAGE.AssetProperties AP, SAGE.AssetTypeProperties ATP 
						WHERE AP.AssetTypePropertyId=ATP.AssetTypePropertyId 
						AND AP.AssetPropertyValue <> '3' 
						AND ATP.AssetTypePropertyName='com.ibm.rfid.atv.status')
    ;
END IF;
IF itemType = 0 AND locationId IS NOT NULL THEN
   -- Retrieve all items with location, zone and last seen time details only
    INSERT INTO SESSION.ASSET_RESULTS
          SELECT DISTINCT ATYPE.AssetTypeName, A.AssetId, TH.TAGID, '', DCOESCHEMA.UNIXTIMESTAMP(BIGINT(TH.DTS)) AS TIME, L.LOCATION_ALIAS, ZONES.ZONE_NAME, AP.AssetPropertyValue
                FROM SAGE.TAGHISTORY TH, SAGE.LOCATION L, SAGE.Assets A, DCOESCHEMA.ITEM_TAG ITAG, SAGE.AssetProperties AP,  SAGE.AssetTypeProperties ATP, SAGE.AssetTypes ATYPE
		,DCOESCHEMA.LOCATION_ZONES LZ, DCOESCHEMA.ZONE_ITEMS ZONEITEMS
		LEFT JOIN DCOESCHEMA.ZONES ZONES ON ZONEITEMS.ZONE_ID=ZONES.ZONE_ID
		WHERE  TH.TAGID = ITAG.TAG_ID AND A.AssetId=ITAG.ITEM_ID AND
				(CASE WHEN ITAG.ENDDATE IS NOT NULL THEN ITAG.ENDDATE - CURRENT TIMEZONE ELSE CURRENT_TIMESTAMP - CURRENT TIMEZONE END ) >=  DCOESCHEMA.UNIXTIMESTAMP(BIGINT(TH.DTS)) AND
				ITAG.STARTDATE - CURRENT TIMEZONE <= DCOESCHEMA.UNIXTIMESTAMP(BIGINT(TH.DTS)) AND
				TH.LOCATION_ID = L.LOCATION_ID AND
				AP.AssetId = A.AssetId AND A.AssetTypeId=ATYPE.AssetTypeId  AND
				ATP.IsPrimaryIdentifier=1 AND 	AP.AssetTypePropertyId = ATP.AssetTypePropertyId
				AND (ZONEITEMS.ISCURRENT='Y' OR ZONEITEMS.ITEM_ID is null) and ZONEITEMS.ITEM_ID=A.AssetId
				AND TH.DTS in (select max(DTS) from SAGE.TAGHISTORY TH2 where TH.TAGID = TH2.TAGID)
				AND TH.LOCATION_ID = locationId
				AND AP.AssetId IN (SELECT AP.AssetId 		
						FROM SAGE.AssetProperties AP, SAGE.AssetTypeProperties ATP 
						WHERE AP.AssetTypePropertyId=ATP.AssetTypePropertyId 
						AND AP.AssetPropertyValue <> '3' 
						AND ATP.AssetTypePropertyName='com.ibm.rfid.atv.status')
    ;
END IF;
IF itemType = 0 AND locationId='' THEN
 -- Retrieve all items with location, zone and last seen time details only
    INSERT INTO SESSION.ASSET_RESULTS
          SELECT DISTINCT ATYPE.AssetTypeName, A.AssetId, TH.TAGID, '', DCOESCHEMA.UNIXTIMESTAMP(BIGINT(TH.DTS)) AS TIME, L.LOCATION_ALIAS, ZONES.ZONE_NAME, AP.AssetPropertyValue
                FROM SAGE.TAGHISTORY TH, SAGE.LOCATION L, SAGE.Assets A, DCOESCHEMA.ITEM_TAG ITAG, SAGE.AssetProperties AP,  SAGE.AssetTypeProperties ATP, SAGE.AssetTypes ATYPE
		,DCOESCHEMA.LOCATION_ZONES LZ, DCOESCHEMA.ZONE_ITEMS ZONEITEMS
		LEFT JOIN DCOESCHEMA.ZONES ZONES ON ZONEITEMS.ZONE_ID=ZONES.ZONE_ID
		WHERE  TH.TAGID = ITAG.TAG_ID AND A.AssetId=ITAG.ITEM_ID AND
				(CASE WHEN ITAG.ENDDATE IS NOT NULL THEN ITAG.ENDDATE - CURRENT TIMEZONE ELSE CURRENT_TIMESTAMP - CURRENT TIMEZONE END ) >=  DCOESCHEMA.UNIXTIMESTAMP(BIGINT(TH.DTS)) AND
				ITAG.STARTDATE - CURRENT TIMEZONE <= DCOESCHEMA.UNIXTIMESTAMP(BIGINT(TH.DTS)) AND
				TH.LOCATION_ID = L.LOCATION_ID AND
				AP.AssetId = A.AssetId AND A.AssetTypeId=ATYPE.AssetTypeId  AND
				ATP.IsPrimaryIdentifier=1 AND 	AP.AssetTypePropertyId = ATP.AssetTypePropertyId
				AND (ZONEITEMS.ISCURRENT='Y' OR ZONEITEMS.ITEM_ID is null) and ZONEITEMS.ITEM_ID=A.AssetId
				AND TH.DTS in (select max(DTS) from SAGE.TAGHISTORY TH2 where TH.TAGID = TH2.TAGID)
				AND AP.AssetId IN (SELECT AP.AssetId 		
						FROM SAGE.AssetProperties AP, SAGE.AssetTypeProperties ATP 
						WHERE AP.AssetTypePropertyId=ATP.AssetTypePropertyId 
						AND AP.AssetPropertyValue <> '3' 
						AND ATP.AssetTypePropertyName='com.ibm.rfid.atv.status')
		;	
END IF;



    -- Update the parent for each item. Could merge into initial insert

    UPDATE SESSION.ASSET_RESULTS  itemresults
    SET ITEM_PARENT =
    (SELECT DISTINCT AP.AssetPropertyValue
	FROM  SAGE.AssetProperties AP, SAGE.AssetTypeProperties ATP, SAGE.Assets A
	WHERE AP.AssetTypePropertyId=ATP.AssetTypePropertyId
	AND ATP.IsPrimaryIdentifier=1
	AND A.AssetId=AP.AssetId
	AND A.AssetId=(SELECT ParentAssetId FROM SAGE.Assets A WHERE A.AssetId = itemresults.ITEMID));

			
BEGIN
    -- Declare cursor
     DECLARE c1 CURSOR WITH RETURN TO CALLER FOR

		SELECT *
    FROM SESSION.ASSET_RESULTS
    ORDER BY ITEM_TYPE;

    -- Cursor left open for client application
    OPEN c1;
END;
END^

